//Uptime
//Compile only in MS Visual Studio 6.0 due to Pentium Assembly usage
//By Doug Coleman
//July 18, 2000

#include <stdio.h>
#include <conio.h>

#define PROCESSOR_SPEED 534626221
//#define cycles_since_program_start

int main(int argc, char* argv[])
{
	unsigned long ti1, ti2;
	double sum=0, begin=0, d=0;
	long int secs=0, mins=0, hours=0, days=0;
	long int lastsec=0;
	long int c=0;
 
#ifdef cycles_since_program_start
	_asm rdtsc

	_asm mov ti1, edx
	_asm mov ti2, eax

	begin = ti1;
	begin *= 4294967296;
	begin += ti2;
#endif
	
	while (!kbhit())
	{
		_asm rdtsc

		_asm mov ti1, edx
		_asm mov ti2, eax

		sum = ti1;
		sum *= 4294967296;
		sum += ti2;

		d=sum/(float)PROCESSOR_SPEED;
		c=(int)d;
		days=c/86400;
		c = c % 86400;
		hours = c/3600;
		c=c%3600;
		mins=c/60;
		secs = c%60;
		if (secs != lastsec)
		{
			lastsec=secs;
			printf("\nThe computer has been up %d days, %d hours, %d minutes, and %d seconds.", days, hours, mins, secs);
			printf("\ncycles = %.0f\n", (sum));
		}
	}
	
	getch();
	return 0;
}